-- Tests for Exists, In and Inner Join

-- Prime caches, compile plans

-- Large

SELECT PrimaryTable_Large.ID, PrimaryTable_Large.SomeColumn 
	FROM PrimaryTable_Large
	WHERE PrimaryTable_Large.SomeColumn IN (SELECT SecondaryTable_Large.LookupColumn FROM SecondaryTable_Large)

SELECT PrimaryTable_Large.ID, PrimaryTable_Large.SomeColumn 
	FROM PrimaryTable_Large
	WHERE EXISTS (SELECT 1 FROM SecondaryTable_Large WHERE SecondaryTable_Large.LookupColumn = PrimaryTable_Large.SomeColumn)

SELECT PrimaryTable_Large.ID, PrimaryTable_Large.SomeColumn
	FROM PrimaryTable_Large
		INNER JOIN SecondaryTable_Large ON PrimaryTable_Large.SomeColumn = SecondaryTable_Large.LookupColumn

-- Medium

SELECT PrimaryTable_Medium.ID, PrimaryTable_Medium.SomeColumn 
	FROM PrimaryTable_Medium
	WHERE PrimaryTable_Medium.SomeColumn IN (SELECT SecondaryTable_Medium.LookupColumn FROM SecondaryTable_Medium)

SELECT PrimaryTable_Medium.ID, PrimaryTable_Medium.SomeColumn 
	FROM PrimaryTable_Medium
	WHERE EXISTS (SELECT 1 FROM SecondaryTable_Medium WHERE SecondaryTable_Medium.LookupColumn = PrimaryTable_Medium.SomeColumn)

SELECT PrimaryTable_Medium.ID, PrimaryTable_Medium.SomeColumn
	FROM PrimaryTable_Medium
		INNER JOIN SecondaryTable_Medium ON PrimaryTable_Medium.SomeColumn = SecondaryTable_Medium.LookupColumn

-- Small

SELECT PrimaryTable_Small.ID, PrimaryTable_Small.SomeColumn 
	FROM PrimaryTable_Small
	WHERE PrimaryTable_Small.SomeColumn IN (SELECT SecondaryTable_Small.LookupColumn FROM SecondaryTable_Small)

SELECT PrimaryTable_Small.ID, PrimaryTable_Small.SomeColumn 
	FROM PrimaryTable_Small
	WHERE EXISTS (SELECT 1 FROM SecondaryTable_Small WHERE SecondaryTable_Small.LookupColumn = PrimaryTable_Small.SomeColumn)

SELECT PrimaryTable_Small.ID, PrimaryTable_Small.SomeColumn
	FROM PrimaryTable_Small
		INNER JOIN SecondaryTable_Small ON PrimaryTable_Small.SomeColumn = SecondaryTable_Small.LookupColumn

-----------------------------------------------------------------------------------------------------------------------------
-- Run from here for the test. Ensure that the trace is running
-----------------------------------------------------------------------------------------------------------------------------

SELECT PrimaryTable_Large.ID, PrimaryTable_Large.SomeColumn 
	FROM PrimaryTable_Large
	WHERE PrimaryTable_Large.SomeColumn IN (SELECT SecondaryTable_Large.LookupColumn FROM SecondaryTable_Large)

SELECT PrimaryTable_Large.ID, PrimaryTable_Large.SomeColumn 
	FROM PrimaryTable_Large
	WHERE EXISTS (SELECT 1 FROM SecondaryTable_Large WHERE SecondaryTable_Large.LookupColumn = PrimaryTable_Large.SomeColumn)

SELECT PrimaryTable_Large.ID, PrimaryTable_Large.SomeColumn
	FROM PrimaryTable_Large
		INNER JOIN SecondaryTable_Large ON PrimaryTable_Large.SomeColumn = SecondaryTable_Large.LookupColumn
GO 10

-- Medium

SELECT PrimaryTable_Medium.ID, PrimaryTable_Medium.SomeColumn 
	FROM PrimaryTable_Medium
	WHERE PrimaryTable_Medium.SomeColumn IN (SELECT SecondaryTable_Medium.LookupColumn FROM SecondaryTable_Medium)

SELECT PrimaryTable_Medium.ID, PrimaryTable_Medium.SomeColumn 
	FROM PrimaryTable_Medium
	WHERE EXISTS (SELECT 1 FROM SecondaryTable_Medium WHERE SecondaryTable_Medium.LookupColumn = PrimaryTable_Medium.SomeColumn)

SELECT PrimaryTable_Medium.ID, PrimaryTable_Medium.SomeColumn
	FROM PrimaryTable_Medium
		INNER JOIN SecondaryTable_Medium ON PrimaryTable_Medium.SomeColumn = SecondaryTable_Medium.LookupColumn
GO 10

-- Smalle

	SELECT PrimaryTable_Small.ID, PrimaryTable_Small.SomeColumn 
		FROM PrimaryTable_Small
		WHERE PrimaryTable_Small.SomeColumn IN (SELECT SecondaryTable_Small.LookupColumn FROM SecondaryTable_Small)

	SELECT PrimaryTable_Small.ID, PrimaryTable_Small.SomeColumn 
		FROM PrimaryTable_Small
		WHERE EXISTS (SELECT 1 FROM SecondaryTable_Small WHERE SecondaryTable_Small.LookupColumn = PrimaryTable_Small.SomeColumn)

	SELECT PrimaryTable_Small.ID, PrimaryTable_Small.SomeColumn
		FROM PrimaryTable_Small
			INNER JOIN SecondaryTable_Small ON PrimaryTable_Small.SomeColumn = SecondaryTable_Small.LookupColumn
	GO 10
-- End test. Stop trace.