-- Tests for Not Exists, Not In and Left Outer Join ... Is Null

-- Prime caches, compile plans

SELECT PrimaryTable_Large.ID, PrimaryTable_Large.SomeColumn 
	FROM PrimaryTable_Large
	WHERE PrimaryTable_Large.SomeColumn NOT IN (SELECT SecondaryTable_Large.LookupColumn FROM SecondaryTable_Large)

SELECT PrimaryTable_Large.ID, PrimaryTable_Large.SomeColumn 
	FROM PrimaryTable_Large
	WHERE NOT EXISTS (SELECT 1 FROM SecondaryTable_Large WHERE SecondaryTable_Large.LookupColumn = PrimaryTable_Large.SomeColumn)

SELECT PrimaryTable_Large.ID, PrimaryTable_Large.SomeColumn
	FROM PrimaryTable_Large
		LEFT OUTER JOIN SecondaryTable_Large ON PrimaryTable_Large.SomeColumn = SecondaryTable_Large.LookupColumn
	WHERE dbo.SecondaryTable_Large.ID IS NULL

-- Medium

SELECT PrimaryTable_Medium.ID, PrimaryTable_Medium.SomeColumn 
	FROM PrimaryTable_Medium
	WHERE PrimaryTable_Medium.SomeColumn NOT IN (SELECT SecondaryTable_Medium.LookupColumn FROM SecondaryTable_Medium)

SELECT PrimaryTable_Medium.ID, PrimaryTable_Medium.SomeColumn 
	FROM PrimaryTable_Medium
	WHERE NOT EXISTS (SELECT 1 FROM SecondaryTable_Medium WHERE SecondaryTable_Medium.LookupColumn = PrimaryTable_Medium.SomeColumn)

SELECT PrimaryTable_Medium.ID, PrimaryTable_Medium.SomeColumn
	FROM PrimaryTable_Medium
		LEFT OUTER JOIN SecondaryTable_Medium ON PrimaryTable_Medium.SomeColumn = SecondaryTable_Medium.LookupColumn
	WHERE dbo.SecondaryTable_Medium.ID IS NULL

-- Small

SELECT PrimaryTable_Small.ID, PrimaryTable_Small.SomeColumn 
	FROM PrimaryTable_Small
	WHERE PrimaryTable_Small.SomeColumn NOT IN (SELECT SecondaryTable_Small.LookupColumn FROM SecondaryTable_Small)

SELECT PrimaryTable_Small.ID, PrimaryTable_Small.SomeColumn 
	FROM PrimaryTable_Small
	WHERE NOT EXISTS (SELECT 1 FROM SecondaryTable_Small WHERE SecondaryTable_Small.LookupColumn = PrimaryTable_Small.SomeColumn)

SELECT PrimaryTable_Small.ID, PrimaryTable_Small.SomeColumn
	FROM PrimaryTable_Small
		LEFT OUTER JOIN SecondaryTable_Small ON PrimaryTable_Small.SomeColumn = SecondaryTable_Small.LookupColumn
	WHERE dbo.SecondaryTable_Small.ID IS NULL

-----------------------------------------------------------------------------------------------------------------------------
-- Run from here for the test. Ensure that the trace is running
-----------------------------------------------------------------------------------------------------------------------------

SELECT PrimaryTable_Large.ID, PrimaryTable_Large.SomeColumn 
	FROM PrimaryTable_Large
	WHERE PrimaryTable_Large.SomeColumn NOT IN (SELECT SecondaryTable_Large.LookupColumn FROM SecondaryTable_Large)

SELECT PrimaryTable_Large.ID, PrimaryTable_Large.SomeColumn 
	FROM PrimaryTable_Large
	WHERE NOT EXISTS (SELECT 1 FROM SecondaryTable_Large WHERE SecondaryTable_Large.LookupColumn = PrimaryTable_Large.SomeColumn)

SELECT PrimaryTable_Large.ID, PrimaryTable_Large.SomeColumn
	FROM PrimaryTable_Large
		LEFT OUTER JOIN SecondaryTable_Large ON PrimaryTable_Large.SomeColumn = SecondaryTable_Large.LookupColumn
	WHERE dbo.SecondaryTable_Large.ID IS NULL
GO 10
-- Medium

SELECT PrimaryTable_Medium.ID, PrimaryTable_Medium.SomeColumn 
	FROM PrimaryTable_Medium
	WHERE PrimaryTable_Medium.SomeColumn NOT IN (SELECT SecondaryTable_Medium.LookupColumn FROM SecondaryTable_Medium)

SELECT PrimaryTable_Medium.ID, PrimaryTable_Medium.SomeColumn 
	FROM PrimaryTable_Medium
	WHERE NOT EXISTS (SELECT 1 FROM SecondaryTable_Medium WHERE SecondaryTable_Medium.LookupColumn = PrimaryTable_Medium.SomeColumn)

SELECT PrimaryTable_Medium.ID, PrimaryTable_Medium.SomeColumn
	FROM PrimaryTable_Medium
		LEFT OUTER JOIN SecondaryTable_Medium ON PrimaryTable_Medium.SomeColumn = SecondaryTable_Medium.LookupColumn
	WHERE dbo.SecondaryTable_Medium.ID IS NULL
GO 10
-- Small

SELECT PrimaryTable_Small.ID, PrimaryTable_Small.SomeColumn 
	FROM PrimaryTable_Small
	WHERE PrimaryTable_Small.SomeColumn NOT IN (SELECT SecondaryTable_Small.LookupColumn FROM SecondaryTable_Small)

SELECT PrimaryTable_Small.ID, PrimaryTable_Small.SomeColumn 
	FROM PrimaryTable_Small
	WHERE NOT EXISTS (SELECT 1 FROM SecondaryTable_Small WHERE SecondaryTable_Small.LookupColumn = PrimaryTable_Small.SomeColumn)

SELECT PrimaryTable_Small.ID, PrimaryTable_Small.SomeColumn
	FROM PrimaryTable_Small
		LEFT OUTER JOIN SecondaryTable_Small ON PrimaryTable_Small.SomeColumn = SecondaryTable_Small.LookupColumn
	WHERE dbo.SecondaryTable_Small.ID IS NULL	
GO 10

-- End test. Stop trace.